angular.module('NoiseTwitter', ['ngRoute']);

angular.module('NoiseTwitter').config(['$locationProvider', '$routeProvider', function ($locationProvider, $routeProvider) {
  $routeProvider
    .when('/', {
      controller: 'MainController',
      templateUrl: 'mainControllerTemplate'/*,
      resolve: function () {
        // get stuff from the internet prior to calling MainController
      }*/ 
    })
    .when('/tweets/:id', {
      controller: 'TweetController',
      templateUrl: 'tweetControllerTemplate'
    });
}]);

angular.module('NoiseTwitter').run(['$rootScope', function ($rootScope) {
  $rootScope.tweets = [
    {
      id: "1",
      author: "JeffreyATW",
      content: "You give love a bad name."
    },
    {
      id: "2",
      author: "JeffreyATW",
      content: "Old McDonald had a farm."
    },
    {
      id: "3",
      author: "JeffreyATW",
      content: "I'm a little teapot, short and stout."
    }
  ];
}]);

angular.module('NoiseTwitter').controller('MainController', ['$scope', function ($scope) {
  $scope.tweetContent = "";

  $scope.isButtonDisabled = function () {
    return $scope.tweetContent.length === 0 || $scope.tweetContent.length > 140;
  };

  $scope.addTweet = function () {
    $scope.tweets.unshift({
      author: "JeffreyATW",
      content: $scope.tweetContent,
      id: "yay"
    });

    $scope.tweetContent = "";
  };
}]);

angular.module('NoiseTwitter').controller('TweetController', ['$scope', '$route', function ($scope, $route) {
  for (var i = 0; i < $scope.tweets.length; i += 1) {
    if ($scope.tweets[i].id === $route.current.params.id) {
      $scope.tweet = $scope.tweets[i];
    }
  }
}]);

angular.module('NoiseTwitter').directive('tweet', function () {
  return {
    scope: {
      data: '=', // = means two-way binding!
      cool: '='
    },
    restrict: 'E', // E stands for element!
    link: function (scope) {
      console.log(scope.data);

      scope.favorite = function () {
        scope.data.favorited = !scope.data.favorited;
      };

      scope.retweet = function () {
        scope.data.retweeted = !scope.data.retweeted;
      };
    },
    templateUrl: 'tweetTemplate'
  };
});